// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "PCPages32.h"
#include "ChildView.h"
#include "PG_RHSTabWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CSplitterWnd )
	//{{AFX_MSG_MAP(CChildView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

void CChildView::OnDrawSplitter(CDC* pDC, ESplitType nType, const CRect& rectArg)
{
	// if pDC == NULL, then just invalidate
	if (pDC == NULL)
	  {
		  RedrawWindow(rectArg, NULL, RDW_INVALIDATE|RDW_NOCHILDREN);
		  return;
	  }
	ASSERT_VALID(pDC);

	// otherwise, actually draw
	CRect rect = rectArg;
	switch (nType)
	{
	case splitBorder:
		pDC->Draw3dRect(rect, GetSysColor(COLOR_BTNSHADOW), GetSysColor(COLOR_BTNHILIGHT));
		rect.InflateRect(-GetSystemMetrics(SM_CYBORDER), -GetSystemMetrics(SM_CYBORDER));
		pDC->Draw3dRect(rect, GetSysColor(COLOR_BTNFACE), GetSysColor(COLOR_BTNFACE));
		return;

	case splitIntersection:
		break;

	case splitBox:
		pDC->Draw3dRect(rect, GetSysColor(COLOR_BTNFACE), GetSysColor(COLOR_WINDOWFRAME));
		rect.InflateRect(-GetSystemMetrics(SM_CYBORDER), -GetSystemMetrics(SM_CYBORDER));
		pDC->Draw3dRect(rect, GetSysColor(COLOR_BTNHILIGHT), GetSysColor(COLOR_BTNSHADOW));
		rect.InflateRect(-GetSystemMetrics(SM_CYBORDER), -GetSystemMetrics(SM_CYBORDER));
		// fall through...
	case splitBar:
		pDC->Draw3dRect(rect, GetSysColor(COLOR_BTNHILIGHT), GetSysColor(COLOR_BTNSHADOW));
		rect.InflateRect(-GetSystemMetrics(SM_CYBORDER), -GetSystemMetrics(SM_CYBORDER));
		break;

	default:
		ASSERT(FALSE);  // unknown splitter type
	}

	// fill the middle
	COLORREF clr = GetSysColor(COLOR_BTNFACE);
	pDC->FillSolidRect(rect, clr);
}

