// PCPages32.h : main header file for the PCPAGES32 application
//

#if !defined(AFX_PCPAGES32_H__279C66F7_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
#define AFX_PCPAGES32_H__279C66F7_14FB_11D3_9024_0020AFF7CE08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "QDSManager.h"
#include "PG_EntryListCtrl.h"
#include "PG_EntryViewCtrl.h"
#include "PG_DITCtrl.h"
#include "PG_SplashWnd.h"
#include "PG_Configuration.h"
#include "PG_WaitDialog.h"
#include "PG_FlashWnd.h"

/////////////////////////////////////////////////////////////////////////////
// CPCPages32App:
// See PCPages32.cpp for the implementation of this class
//
class CMainFrame;
class CPCPages32App : public CWinApp
{
public:
	CPCPages32App();
	virtual ~CPCPages32App();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPCPages32App)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual BOOL OnIdle(LONG lCount);
	//}}AFX_VIRTUAL

// Implementation

public:
	//{{AFX_MSG(CPCPages32App)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	QDSManager *DS() { return m_pDS; } ;
	Oidtable *Oidtable() { return m_pDS->Table(); } ;
	PG_Configuration &Config() { return m_Config; } ;

public:
	PG_EntryListCtrl &EntryListDisplay() { return m_entryListDisplay ; } ;
	void ShowEntryListDisplay();

	PG_EntryListCtrl &EntryListContainer() { return m_entryListContainer ; } ;
	void ShowEntryListContainer();

	PG_DITCtrl &DITDisplay() { return m_ditDisplay ; } ;
	void ShowDITDisplay();

	PG_EntryViewCtrl &EntryView() { return m_entryView; } ;
	void ShowEntryView();

public:
	//
	// Registry key/value access
	HKEY OpenAppKey( char *pGetKeyName );
	BOOL QueryValue
		( HKEY hKey, char *pValueName, DWORD dwWantType, BYTE *pBuf, DWORD *pBufLen );

public:
	//
	// Wait mode is enabled when the directory is being accessed
	void WaitMode( BOOL bOn );
	PG_WaitDialog *WaitDialog();

public:
	//
	// Return the main window
	CMainFrame *MainFrame();

	//
	// Display a "zoom" visual notifier
	void Flash( CWnd *pParentWnd, CRect &rFromRect, CRect &rToRect );

public:
	//
	// Status bar message functions
	void SetMessageText( LPCTSTR pStr, BOOL bFlash = FALSE );
	void FlashMessageText();

	//
	// Display an error dialog containing the given string resource
	void ErrorBox( UINT msgId );

private:
	//
	// Load base configuration from the registry
	BOOL LoadBootstrap();

private:
	//
	// The directory context
	QDSManager *m_pDS;

	//
	// The entry list control for display search and browse results
	PG_EntryListCtrl m_entryListDisplay;

	//
	// The entry list control for entry collections
	PG_EntryListCtrl m_entryListContainer;

	//
	// The entry display control
	PG_EntryViewCtrl m_entryView;

	//
	// The directory browser control
	PG_DITCtrl m_ditDisplay;

	//
	// The splash screen
	PG_SplashWnd m_splashWnd;

	//
	// Window used to display zoom effect
	PG_FlashWnd m_flashWnd;

private:
	//
	// Configuration
	PG_Configuration m_Config;

	//
	// From command line. Run without attempting to connect to a directory - developer mode
	BOOL m_bNoConnect;

	//
	// Information loaded from the registry
	CString m_sConfDN;
	CString m_sHost;
	int m_nPort;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PCPAGES32_H__279C66F7_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
