// PG_DisplayEntryHandler.cpp: implementation of the PG_DisplayEntryHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_DisplayEntryHandler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PG_DisplayEntryHandler::PG_DisplayEntryHandler()
{
}

PG_DisplayEntryHandler::~PG_DisplayEntryHandler()
{
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleActivity
//
void PG_DisplayEntryHandler::HandleActivity( QDUAActivity event, QRequestMsg *pMsg )
{
	switch ( event )
		{
		case DUAresult:
			HandleResult( pMsg );
			break;

		case DUAreport:
			HandleReport( pMsg );
			break;

		case DUAerror:
			HandleError( pMsg );
			break;

		case DUAcomplete:
			HandleComplete( pMsg );
			break;

		case DUAcancel:
			break;

		case DUAabort:
			HandleAbort( pMsg );
			break;
		}
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleResult
//
void PG_DisplayEntryHandler::HandleResult( QRequestMsg *pMsg )
{
	extern CPCPages32App theApp;

	QReadResult *pResult = reinterpret_cast<QReadResult *>( pMsg->Message() );
	QEntry *pEntry = pResult->GetEntry();

	theApp.EntryView().SetEntry( pEntry );
	theApp.ShowEntryView();

	delete pResult;
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleReport
//
void PG_DisplayEntryHandler::HandleReport( QRequestMsg *pMsg )
{
	extern CPCPages32App theApp;
	CString dnStr, msgStr;

	QReadReport *pReport =
		static_cast<QReadReport *>( pMsg->Message() );

	pReport->DN().GetFriendlyDN( dnStr );

	switch ( pReport->Type() )
		{
		case QRRInvoked:
			msgStr.Format( PGS_STATREP_READ_INVOKED, dnStr, pReport->Host() );
			theApp.SetMessageText( msgStr );
			break;
		}

	delete pReport;
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleComplete
//
void PG_DisplayEntryHandler::HandleComplete( QRequestMsg *pMsg )
{
	extern CPCPages32App theApp;
	CString dnStr, msgStr;

	QReadCompletionReport *pReport = 
		static_cast<QReadCompletionReport *>( pMsg->Message() );

	pReport->DN().GetFriendlyDN( dnStr );
	msgStr.Format( PGS_STATREP_READ_SUCCESS, dnStr );

	theApp.SetMessageText( msgStr, TRUE );
	delete pReport;
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleError
//
void PG_DisplayEntryHandler::HandleError( QRequestMsg *pMsg )
{
	extern CPCPages32App theApp;
	CString dnStr, msgStr;

	QReadErrorReport *pReport = 
		static_cast<QReadErrorReport *>( pMsg->Message() );

	pReport->DN().GetFriendlyDN( dnStr );
	msgStr.Format( PGS_STATREP_READ_FAILED, dnStr, pReport->Host() );

	theApp.SetMessageText( msgStr );
	theApp.FlashMessageText();

	delete pReport;
}

//////////////////////////////////////////////////////////////////////
// PG_DisplayEntryHandler::HandleAbort
//
void PG_DisplayEntryHandler::HandleAbort( QRequestMsg *pMsg )
{
}

