// QReadRequest.cpp: implementation of the QReadRequest class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Query32.h"
#include "QReadRequest.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

QReadRequest::QReadRequest
  ( QDSManager *manager_arg, QRequestID req_id_arg, QRequester *requester_arg,
    QDN &dn_arg, PtrList<QAttrT> at_list_arg )
:
QRequest( manager_arg, req_id_arg, requester_arg )
{
  WIN32_GUFF();

  dn = dn_arg;
  ldap_msg_id = -1;


}

QReadRequest::~QReadRequest()
{
  WIN32_GUFF();

  if ( Finished() == FALSE )
    Abort();

	Manager()->DeregisterRequest( ID() );
}

//////////////////////////////////////////////////////////////////////
// Invoke the specified read operation
BOOL QReadRequest::Invoke( QError *& err )
{
  //
  // Record request invocation
  QRequest::invoked = TRUE;

	//
	// Make sure connection is alive
	if ( ds->BindManager()->BindWait( conn_id, err ) == FALSE )
		return FALSE;

	//
	// Get search base DN in string form
	CString dn_str;
	base_dn.GetDN( dn_str );

	//
	// Compute search scope
	int scope =
		( base_dn.GetRDNCount() >= 2 ? LDAP_SCOPE_SUBTREE : LDAP_SCOPE_ONELEVEL );

	//
	// XXX Attribute selection fixed at objectClass at present. Will need to
	// XXX be configurable later (QFormOp::Invoke).
	char *attrs[2];
	attrs[0] = "objectClass";
	attrs[1] = NULL;

	//
	// No timeout for the search operation
	struct timeval zerotime;
	zerotime.tv_sec = zerotime.tv_usec = 0L;
	
	//
	// Invoke LDAP search operation

	int ldap_err = ldap_search_ext
		( GetLDAPContext(),	(LPCTSTR) dn_str,	scope, (LPCTSTR) filter, attrs, 0,
			NULL, NULL, NULL, -1, &ldap_msg_id );

	op_invoked = TRUE;

	//
	// Check for errors
	if ( ldap_err != LDAP_SUCCESS )
		{
			CString err_str;
			err = new QError( ldap_err );
			err->Print( err_str );

#ifdef _DEBUG
      CString msg;
      msg.Format( "LDAP search invocation failed - LDAP error string was:\n'%s'.\n", (LPCTSTR) err_str );
			OutputDebugString( msg );
#endif

			return FALSE;
		}

  Manager()->RegisterRequest( this );
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// Process an LDAP response
BOOL QReadRequest::HandleLDAPMessage( LDAP *pLDAP, LDAPMessage *msg, QError *&err )
{
  WIN32_GUFF();

  switch ( 
}

//////////////////////////////////////////////////////////////////////
// Check whether an LDAP operation was invoked by this request
BOOL QReadRequest::IsTaskOwner( int ldap_msg_id_arg )
{
  if ( ldap_msg_id != -1 && ldap_msg_id == ldap_msg_id_arg )
    return TRUE;
  else
    return FALSE;
}

//////////////////////////////////////////////////////////////////////
// Abort an incomplete request
void QReadRequest::Abort()
{
}





