// QAttr.cpp: implementation of the QAttr class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Query32.h"
#include "QAttr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

QAttr::QAttr( QAttrT *attrt )
{
  this->attrt = attrt;
}

QAttr::~QAttr()
{
  WIN32_GUFF();

  POSITION pos = value_list.GetHeadPosition();
  while ( pos != NULL )
    {
      QValue *value = value_list.GetNext( pos );
      delete value;
    }
}

void QAttr::PrintValues( QStringList &str_list )
{
  WIN32_GUFF();

  POSITION val_pos = value_list.GetHeadPosition();
  while ( val_pos != NULL )
    {
      QValue *value = value_list.GetNext( val_pos );
      CString str;
      value->Print( str );
      str_list.AddTail( str );
    }
}

void QAttr::GetValues( PtrList<QValue> &get_val_list )
{
  WIN32_GUFF();

  POSITION val_pos = value_list.GetHeadPosition();
  while ( val_pos != NULL )
    {
      get_val_list.AddTail( value_list.GetNext( val_pos ) );
    }
}

void QAttr::AddValue( char *ldap_val_ptr, unsigned long len )
{
  WIN32_GUFF();

  QValue *val = new QValue( attrt->Syntax(), ldap_val_ptr, len );
  if ( val != NULL )
    value_list.AddTail( val );
}

//////////////////////////////////////////////////////////////////////
// Create a copy of this attribute.
//////////////////////////////////////////////////////////////////////

QAttr *QAttr::Copy()
{
  WIN32_GUFF();

  // XXX Unimplemented: QAttr::Copy
  return NULL;
}

//////////////////////////////////////////////////////////////////////
// QValue Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

QValue::QValue( QSyntax *syntax_arg, char *ldap_val_ptr_arg, unsigned long len_arg )
{
  syntax = syntax_arg;
  ldap_val_ptr = new char[ len_arg ];
  memcpy( ldap_val_ptr, ldap_val_ptr_arg, len_arg );
  len = len_arg;
}

QValue::~QValue()
{
  delete ldap_val_ptr;
}

//////////////////////////////////////////////////////////////////////
// Present the value as a user friendly string
//////////////////////////////////////////////////////////////////////

void QValue::Print( CString &str )
{
	if ( syntax == NULL )
		str = "";
	else
		syntax->Print( str, ldap_val_ptr );
}

//////////////////////////////////////////////////////////////////////
// Present the value as a raw data string
//////////////////////////////////////////////////////////////////////

void QValue::PrintRaw( CString &str )
{
	if ( syntax == NULL )
		str = "";
	else
		syntax->PrintRaw( str, ldap_val_ptr );
}

////////////////////////////////////////////////////////////////////////////////
// Determine equality of two attribute values (if syntaxes are the same).
////////////////////////////////////////////////////////////////////////////////

BOOL QValue::operator==( QValue &v )
{
  if ( this->syntax != v.Syntax() )
    return FALSE;

  if ( syntax->Compare( *this, v ) != 0 )
    return FALSE;

  return TRUE;        
}
