// QRULESET.h: interface for the QRULESET class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(QRULESET_H__INCLUDED_)
#define QRULESET_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "stdafx.h"
#include "QSearchClass.h"
#include "QEntry.h"

// This class encapsulates a set of schema heuristics
class QRuleSet
{
public:
  QRuleSet( const CString &name, PtrList<QSearchClass> &class_list );
  virtual ~QRuleSet();

public:
  void GetClassList( PtrList<QSearchClass> &class_list );
	QSearchClass *FindMatchingClass( QEntry *entry );
  QSearchClass *GetNamedClass( CString &name );
  const CString &Name() { return name ; } ;

private:
  CString name;
  PtrList<QSearchClass> srch_class_list;
};

#endif // QRULESET_H__INCLUDED_
